// This script builds the Reference-FMUs for FMI 2.0 and 3.0
//
// expect a working msvc compiler, cmake and wsl installed
// lines with "EDIT:" should be updated to match your environment

pre_pwd = pwd();
// EDIT: Change this path to the location of the Reference-FMUs repository
cd E:\nosave\work\dependencies\Reference-FMUs
// EDIT: Select the cmake config "Debug" or "Release"
config = "Release";

for v = ["2" "3"]

    rmdir("build_win_v"+v, "s");
    mkdir("build_win_v"+v);

    cd("build_win_v"+v);
    unix_w("cmake -DFMI_VERSION=" + v + " ..");
    unix_w("cmake --build . --config " + config);
    cd("..");

    rmdir("build_linux_v"+v, "s");
    mkdir("build_linux_v"+v);

    cd("build_linux_v"+v);
    unix_w("wsl -- cmake -DFMI_VERSION=" + v + " ..");
    unix_w("wsl -- cmake --build . --config " + config);

    cd("..");

    // update the FMUs to available in tests directory
    dest = fullfile(pre_pwd, "tests", "unit_tests", "Reference-FMUs", v + ".0");
    for fmu_fullpath = fullpath(ls(dest+"\*.fmu"))'
        // add / update all FMU files
        unix_w("cd "+fullfile("build_win_v"+v, "temp", basename(fmu_fullpath))+ " && zip -0r " + fmu_fullpath + " *")
        unix_w("cd "+fullfile("build_linux_v"+v, "temp", basename(fmu_fullpath))+ " && zip -0ur " + fmu_fullpath + " *")
    end
end

cd(pre_pwd);
